import { Body, Controller, Get, Param, Post } from '@nestjs/common';
import { AppService } from './app.service';
import { Danmu } from './danmu/danmu.entity';

@Controller('/api')
export class AppController {
  constructor(private readonly appService: AppService) {}

  @Post('/top')
  async top(): Promise<Danmu[]> {
    return await this.appService.top();
  }

  @Get('/msg_content/:user_id')
  async msgContent(@Param('user_id') user_id: string) {
    return await this.appService.msgContent(user_id);
  }
}
